/* mylc3as.h */

typedef struct insn_struct insn_t;

/* Opcode definitions */
enum opcodes_t { 
  // LC3 opcodes
  BR, ADD, LD, ST, JSR_JSRR, AND, LDR, STR, 
  RTI, NOT, LDI, STI, JMP_RET, MUL, LEA, TRAP, SUB,
  // assembler directives
  ORIG, FILL, BLKW, STRINGZ,
  // no operation
  UNDEF
};

struct insn_struct {
  enum opcodes_t opcode;  // the opcode of instruction (see above)
  char* label;            // label on this line (can be NULL)
  int first_reg;          // 1st reg number (-1 implies there isn't one)
  int second_reg;         // 2nd reg number (-1 implies there isn't one)
  int third_reg;          // 3rd reg number (-1 implies there isn't one)
  int offset_immediate;   // immediate or offset value
  char* label_ref;        // label referenced by BR/LD/ST/JSR/LDI/STI/LEA/FILL
  char* string;           // string for STRINGZ directive
  int n;                  // neg bit (only for BR)
  int z;                  // zero bit (only for BR)
  int p;                  // pos bit (only for BR)
  insn_t* next;           // pointer to next instruction in list
};

void pass_one(insn_t* insn_ptr);
void pass_two(insn_t* insn_ptr);
void pass_three(insn_t* insn_ptr);

